
using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class XMLNodeList : ArrayList
{
	public int GetCount()
	{
		return Count;
	}
	
	public XMLNode GetElement(int i)
	{
		return this[i] as XMLNode;
	}
	
	public object Pop()
	{
		object thing = this[ this.Count-1 ];
		this.RemoveAt( this.Count-1 );
		return thing;
	}
	
	public void Push( object thing )
	{
		this.Add( thing );
	}
}

public class XMLNode : Dictionary<string, object> {

	public XMLNodeList GetNodeList ( string path  ){
		return GetObject(path) as XMLNodeList;
	}
	
	public XMLNode  GetNode ( string path  ){
		return GetObject(path) as XMLNode;
	}
	
	public string GetValue ( string path  ){
		return GetObject(path) as string;
	}
	
	
	public int  GetHowManyNodes ( string path  ){
		XMLNodeList nodes = GetObject(path) as XMLNodeList;
		
		return nodes.Count;
	}
	
	private object GetObject ( string path  ){
		string[] bits=path.Split(">"[0]);
		XMLNode currentNode=this;
		XMLNodeList currentNodeList = null;
		bool  listMode=false;
		object ob;
		for(int i=0;i<bits.Length;i++){
			 if(listMode){
				ob=currentNode=currentNodeList[int.Parse(bits[i])] as XMLNode;
				listMode=false;
			 }else{
				ob = null;
				if( currentNode.ContainsKey(bits[i]) )
					ob=currentNode[bits[i]];
				if(ob is ArrayList){
					currentNodeList=ob as XMLNodeList;
					listMode=true;
				}else{
					// reached a leaf node/attribute
					if(i!=(bits.Length-1)){
						// unexpected leaf node
						string actualPath="";
						for(int j = 0;j<=i;j++){
							actualPath=actualPath+">"+bits[j];
						}
						Debug.Log("xml path search truncated. Wanted: "+path+" got: "+actualPath);
					}
					return ob;
				}
			 }
		}
		if(listMode) return currentNodeList;
		else return currentNode;
	}
}